/* Tabela CALENCARD: Calendrio de Cardpio                                                                */
/* Descrio: A trigger insere registros na tabela LOGCALENCARD a partir de alteraes na tabela CALENCARD */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Calendrio de Cardpio.                */
/* Criao:                                                                                                */
/* 17/04/2007 - Leandro Rodrigo                                                                            */


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PLA_CALENCARD'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER LOG_PLA_CALENCARD
GO

CREATE TRIGGER LOG_PLA_CALENCARD
ON CALENCARD 
AFTER INSERT, UPDATE 
AS
BEGIN

DECLARE @V_DSREMOTEADDR VARCHAR (50);
DECLARE @V_DSREMOTEHOST VARCHAR (50);
DECLARE @V_DSSERVERRDM  VARCHAR (50);
DECLARE @V_DSSERVMETHOD VARCHAR (30);
DECLARE @V_DSREMOTEOPER VARCHAR (12);

/* Variveis do cursor */
DECLARE @V_IDCOMANDO           VARCHAR(1);
DECLARE @V_DTMESCALENCARD      DATETIME;
DECLARE @V_CDFILIAL            VARCHAR(4);
DECLARE @V_NEW_DTPREVLIBECARD  DATETIME;
DECLARE @V_NEW_DTLIMAPROVFILI  DATETIME;
DECLARE @V_NEW_QTDIAPRORAPROV  smallint;
DECLARE @V_NEW_DTLIMAPROVMATR  DATETIME;
DECLARE @V_OLD_DTPREVLIBECARD  DATETIME;
DECLARE @V_OLD_DTLIMAPROVFILI  DATETIME;
DECLARE @V_OLD_QTDIAPRORAPROV  smallint;
DECLARE @V_OLD_DTLIMAPROVMATR  DATETIME;

   DECLARE C_DADOS CURSOR FOR
     SELECT
       'D' IDCOMANDO,
       DTMESCALENCARD,
       CDFILIAL,
       DTPREVLIBECARD,
       DTLIMAPROVFILI,
       QTDIAPRORAPROV,
       DTLIMAPROVMATR,
       DTPREVLIBECARD,
       DTLIMAPROVFILI,
       QTDIAPRORAPROV,
       DTLIMAPROVMATR
     FROM
       DELETED
     WHERE
       0 = (SELECT COUNT(*) FROM INSERTED)

     UNION ALL

     SELECT
       'U' IDCOMANDO,
       INSERTED.DTMESCALENCARD,
       INSERTED.CDFILIAL,
       INSERTED.DTPREVLIBECARD,
       INSERTED.DTLIMAPROVFILI,
       INSERTED.QTDIAPRORAPROV,
       INSERTED.DTLIMAPROVMATR,
       DELETED.DTPREVLIBECARD,
       DELETED.DTLIMAPROVFILI,
       DELETED.QTDIAPRORAPROV,
       DELETED.DTLIMAPROVMATR
     FROM
       INSERTED,
       DELETED
     WHERE
       INSERTED.CDFILIAL        = DELETED.CDFILIAL    AND
       INSERTED.DTMESCALENCARD  = DELETED.DTMESCALENCARD 

     UNION ALL

     SELECT
       'I' IDCOMANDO,
       DTMESCALENCARD,
       CDFILIAL,
       DTPREVLIBECARD,
       DTLIMAPROVFILI,
       QTDIAPRORAPROV,
       DTLIMAPROVMATR,
       DTPREVLIBECARD,
       DTLIMAPROVFILI,
       QTDIAPRORAPROV,
       DTLIMAPROVMATR
     FROM
       INSERTED
     WHERE
       0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_DTMESCALENCARD,
                                @V_CDFILIAL,
                                @V_NEW_DTPREVLIBECARD,
                                @V_NEW_DTLIMAPROVFILI,
                                @V_NEW_QTDIAPRORAPROV,
                                @V_NEW_DTLIMAPROVMATR,
                                @V_OLD_DTPREVLIBECARD,
                                @V_OLD_DTLIMAPROVFILI,
                                @V_OLD_QTDIAPRORAPROV,
                                @V_OLD_DTLIMAPROVMATR;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SET @V_DSREMOTEADDR = 'VIA BD';
      SET @V_DSREMOTEHOST = 'VIA BD';
      SET @V_DSSERVERRDM  = 'VIA BD';
      SET @V_DSSERVMETHOD = 'VIA BD';
      SET @V_DSREMOTEOPER = 'VIA BD';

      SELECT
         @V_DSREMOTEADDR = ISNULL(MAX(DSREMOTEADDR), 'VIA BD'),
         @V_DSREMOTEHOST = ISNULL(MAX(DSREMOTEHOST), 'VIA BD'),
         @V_DSSERVERRDM  = ISNULL(MAX(DSSERVERRDM ), 'VIA BD'),
         @V_DSSERVMETHOD = ISNULL(MAX(DSSERVMETHOD), 'VIA BD'),
         @V_DSREMOTEOPER = ISNULL(MAX(DSREMOTEOPER), 'VIA BD')
      FROM
         SQLWEBTUNNING
      WHERE
         (NRAUDSID = @@SPID) AND
         (CONVERT(VARCHAR, CONVERT(DATETIME, DTSTARTDATE, 103), 103)) = (SELECT MAX(CONVERT(VARCHAR, CONVERT(DATETIME, DTSTARTDATE, 103), 103))
                                                                         FROM SQLWEBTUNNING S
                                                                         WHERE S.NRAUDSID = @@SPID)

      IF @V_IDCOMANDO = 'I' /* Inserting */ BEGIN

         INSERT INTO LOGCALENCARD
            (DTALTCALENCARD, DTMESCALENCARD, 
             CDFILIAL, CDOPERADOR,
             DTPREVLIBECARDANT, DTLIMAPROVFILIANT,
             QTDIAPRORAPROVANT, DTLIMAPROVMATRANT, 
             DTPREVLIBECARDDEP, DTLIMAPROVFILIDEP, 
             QTDIAPRORAPROVDEP, DTLIMAPROVMATRDEP)
         VALUES
            (GETDATE(), @V_DTMESCALENCARD, 
             @V_CDFILIAL, @V_DSREMOTEOPER,
             NULL, NULL,
             NULL, NULL, 
             @V_NEW_DTPREVLIBECARD, @V_NEW_DTLIMAPROVFILI, 
             @V_NEW_QTDIAPRORAPROV, @V_NEW_DTLIMAPROVMATR);

      END;

      IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN

         INSERT INTO LOGCALENCARD
            (DTALTCALENCARD, DTMESCALENCARD, 
             CDFILIAL, CDOPERADOR,
             DTPREVLIBECARDANT, DTLIMAPROVFILIANT,
             QTDIAPRORAPROVANT, DTLIMAPROVMATRANT, 
             DTPREVLIBECARDDEP, DTLIMAPROVFILIDEP, 
             QTDIAPRORAPROVDEP, DTLIMAPROVMATRDEP)
         VALUES
            (GETDATE(), @V_DTMESCALENCARD, 
             @V_CDFILIAL, @V_DSREMOTEOPER,
             @V_OLD_DTPREVLIBECARD, @V_OLD_DTLIMAPROVFILI,
             @V_OLD_QTDIAPRORAPROV, @V_OLD_DTLIMAPROVMATR, 
             @V_NEW_DTPREVLIBECARD, @V_NEW_DTLIMAPROVFILI, 
             @V_NEW_QTDIAPRORAPROV, @V_NEW_DTLIMAPROVMATR);

      END;

      IF @V_IDCOMANDO = 'D' /* Deleting */ BEGIN

         INSERT INTO LOGCALENCARD
            (DTALTCALENCARD, DTMESCALENCARD, 
             CDFILIAL, CDOPERADOR,
             DTPREVLIBECARDANT, DTLIMAPROVFILIANT,
             QTDIAPRORAPROVANT, DTLIMAPROVMATRANT, 
             DTPREVLIBECARDDEP, DTLIMAPROVFILIDEP, 
             QTDIAPRORAPROVDEP, DTLIMAPROVMATRDEP)
         VALUES
            (GETDATE(), @V_DTMESCALENCARD, 
             @V_CDFILIAL, @V_DSREMOTEOPER,
             @V_OLD_DTPREVLIBECARD, @V_OLD_DTLIMAPROVFILI,
             @V_OLD_QTDIAPRORAPROV, @V_OLD_DTLIMAPROVMATR, 
             NULL, NULL, 
             NULL, NULL);

      END;

      FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                   @V_DTMESCALENCARD,
                                   @V_CDFILIAL,
                                   @V_NEW_DTPREVLIBECARD,
                                   @V_NEW_DTLIMAPROVFILI,
                                   @V_NEW_QTDIAPRORAPROV,
                                   @V_NEW_DTLIMAPROVMATR,
                                   @V_OLD_DTPREVLIBECARD,
                                   @V_OLD_DTLIMAPROVFILI,
                                   @V_OLD_QTDIAPRORAPROV,
                                   @V_OLD_DTLIMAPROVMATR;
   END;
   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_PLA_CALENCARD','4.11.130';
GO
